import { UseQueryOptions, UseMutationOptions } from 'react-query';
import type { DeviceDTO, DeviceControllerGetAllParams, CreateDeviceDTO, DeviceControllerGetMyDevicesParams, DeviceControllerGetParams, SuccessResponseDTO, UpdateDeviceStatusDTO, SmartMeterReadDTO } from './originDeviceRegistryIRECFormAPI.schemas';
declare type AsyncReturnType<T extends (...args: any) => Promise<any>> = T extends (...args: any) => Promise<infer R> ? R : any;
export declare const deviceControllerGetAll: <Data = unknown>(params?: DeviceControllerGetAllParams) => Promise<Data extends unknown ? DeviceDTO[] : Data>;
export declare const getDeviceControllerGetAllQueryKey: (params?: DeviceControllerGetAllParams) => (string | DeviceControllerGetAllParams)[];
export declare const useDeviceControllerGetAll: <Data extends unknown = unknown, Error_1 extends unknown = unknown>(params?: DeviceControllerGetAllParams, queryConfig?: UseQueryOptions<DeviceDTO[], Error_1, DeviceDTO[], import("react-query").QueryKey>) => {
    data: undefined;
    error: null;
    isError: false;
    isIdle: true;
    isLoading: false;
    isLoadingError: false;
    isRefetchError: false;
    isSuccess: false;
    status: "idle";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<DeviceDTO[], Error_1>>;
    remove: () => void;
    queryKey: (string | DeviceControllerGetAllParams)[];
} | {
    data: undefined;
    error: Error_1;
    isError: true;
    isIdle: false;
    isLoading: false;
    isLoadingError: true;
    isRefetchError: false;
    isSuccess: false;
    status: "error";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<DeviceDTO[], Error_1>>;
    remove: () => void;
    queryKey: (string | DeviceControllerGetAllParams)[];
} | {
    data: undefined;
    error: null;
    isError: false;
    isIdle: false;
    isLoading: true;
    isLoadingError: false;
    isRefetchError: false;
    isSuccess: false;
    status: "loading";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<DeviceDTO[], Error_1>>;
    remove: () => void;
    queryKey: (string | DeviceControllerGetAllParams)[];
} | {
    data: DeviceDTO[];
    error: Error_1;
    isError: true;
    isIdle: false;
    isLoading: false;
    isLoadingError: false;
    isRefetchError: true;
    isSuccess: false;
    status: "error";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<DeviceDTO[], Error_1>>;
    remove: () => void;
    queryKey: (string | DeviceControllerGetAllParams)[];
} | {
    data: DeviceDTO[];
    error: null;
    isError: false;
    isIdle: false;
    isLoading: false;
    isLoadingError: false;
    isRefetchError: false;
    isSuccess: true;
    status: "success";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<DeviceDTO[], Error_1>>;
    remove: () => void;
    queryKey: (string | DeviceControllerGetAllParams)[];
};
export declare const deviceControllerCreateDevice: <Data = unknown>(createDeviceDTO: CreateDeviceDTO) => Promise<Data extends unknown ? DeviceDTO : Data>;
export declare const useDeviceControllerCreateDevice: <Data extends unknown = unknown, Error_1 extends unknown = unknown>(mutationConfig?: UseMutationOptions<DeviceDTO, Error_1, {
    data: CreateDeviceDTO;
}, unknown>) => import("react-query").UseMutationResult<DeviceDTO, Error_1, {
    data: CreateDeviceDTO;
}, unknown>;
export declare const deviceControllerGetMyDevices: <Data = unknown>(params?: DeviceControllerGetMyDevicesParams) => Promise<Data extends unknown ? DeviceDTO[] : Data>;
export declare const getDeviceControllerGetMyDevicesQueryKey: (params?: DeviceControllerGetMyDevicesParams) => (string | DeviceControllerGetMyDevicesParams)[];
export declare const useDeviceControllerGetMyDevices: <Data extends unknown = unknown, Error_1 extends unknown = unknown>(params?: DeviceControllerGetMyDevicesParams, queryConfig?: UseQueryOptions<DeviceDTO[], Error_1, DeviceDTO[], import("react-query").QueryKey>) => {
    data: undefined;
    error: null;
    isError: false;
    isIdle: true;
    isLoading: false;
    isLoadingError: false;
    isRefetchError: false;
    isSuccess: false;
    status: "idle";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<DeviceDTO[], Error_1>>;
    remove: () => void;
    queryKey: (string | DeviceControllerGetMyDevicesParams)[];
} | {
    data: undefined;
    error: Error_1;
    isError: true;
    isIdle: false;
    isLoading: false;
    isLoadingError: true;
    isRefetchError: false;
    isSuccess: false;
    status: "error";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<DeviceDTO[], Error_1>>;
    remove: () => void;
    queryKey: (string | DeviceControllerGetMyDevicesParams)[];
} | {
    data: undefined;
    error: null;
    isError: false;
    isIdle: false;
    isLoading: true;
    isLoadingError: false;
    isRefetchError: false;
    isSuccess: false;
    status: "loading";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<DeviceDTO[], Error_1>>;
    remove: () => void;
    queryKey: (string | DeviceControllerGetMyDevicesParams)[];
} | {
    data: DeviceDTO[];
    error: Error_1;
    isError: true;
    isIdle: false;
    isLoading: false;
    isLoadingError: false;
    isRefetchError: true;
    isSuccess: false;
    status: "error";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<DeviceDTO[], Error_1>>;
    remove: () => void;
    queryKey: (string | DeviceControllerGetMyDevicesParams)[];
} | {
    data: DeviceDTO[];
    error: null;
    isError: false;
    isIdle: false;
    isLoading: false;
    isLoadingError: false;
    isRefetchError: false;
    isSuccess: true;
    status: "success";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<DeviceDTO[], Error_1>>;
    remove: () => void;
    queryKey: (string | DeviceControllerGetMyDevicesParams)[];
};
export declare const deviceControllerGet: <Data = unknown>(id: string, params?: DeviceControllerGetParams) => Promise<Data extends unknown ? DeviceDTO : Data>;
export declare const getDeviceControllerGetQueryKey: (id: string, params?: DeviceControllerGetParams) => (string | DeviceControllerGetParams)[];
export declare const useDeviceControllerGet: <Data extends unknown = unknown, Error_1 extends unknown = unknown>(id: string, params?: DeviceControllerGetParams, queryConfig?: UseQueryOptions<DeviceDTO, Error_1, DeviceDTO, import("react-query").QueryKey>) => {
    data: undefined;
    error: null;
    isError: false;
    isIdle: true;
    isLoading: false;
    isLoadingError: false;
    isRefetchError: false;
    isSuccess: false;
    status: "idle";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<DeviceDTO, Error_1>>;
    remove: () => void;
    queryKey: (string | DeviceControllerGetParams)[];
} | {
    data: undefined;
    error: Error_1;
    isError: true;
    isIdle: false;
    isLoading: false;
    isLoadingError: true;
    isRefetchError: false;
    isSuccess: false;
    status: "error";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<DeviceDTO, Error_1>>;
    remove: () => void;
    queryKey: (string | DeviceControllerGetParams)[];
} | {
    data: undefined;
    error: null;
    isError: false;
    isIdle: false;
    isLoading: true;
    isLoadingError: false;
    isRefetchError: false;
    isSuccess: false;
    status: "loading";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<DeviceDTO, Error_1>>;
    remove: () => void;
    queryKey: (string | DeviceControllerGetParams)[];
} | {
    data: DeviceDTO;
    error: Error_1;
    isError: true;
    isIdle: false;
    isLoading: false;
    isLoadingError: false;
    isRefetchError: true;
    isSuccess: false;
    status: "error";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<DeviceDTO, Error_1>>;
    remove: () => void;
    queryKey: (string | DeviceControllerGetParams)[];
} | {
    data: DeviceDTO;
    error: null;
    isError: false;
    isIdle: false;
    isLoading: false;
    isLoadingError: false;
    isRefetchError: false;
    isSuccess: true;
    status: "success";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<DeviceDTO, Error_1>>;
    remove: () => void;
    queryKey: (string | DeviceControllerGetParams)[];
};
export declare const deviceControllerDelete: <Data = unknown>(id: string) => Promise<Data extends unknown ? SuccessResponseDTO : Data>;
export declare const useDeviceControllerDelete: <Data extends unknown = unknown, Error_1 extends unknown = unknown>(mutationConfig?: UseMutationOptions<SuccessResponseDTO, Error_1, {
    id: string;
}, unknown>) => import("react-query").UseMutationResult<SuccessResponseDTO, Error_1, {
    id: string;
}, unknown>;
export declare const deviceControllerUpdateDeviceStatus: <Data = unknown>(id: string, updateDeviceStatusDTO: UpdateDeviceStatusDTO) => Promise<Data extends unknown ? DeviceDTO : Data>;
export declare const useDeviceControllerUpdateDeviceStatus: <Data extends unknown = unknown, Error_1 extends unknown = unknown>(mutationConfig?: UseMutationOptions<DeviceDTO, Error_1, {
    id: string;
    data: UpdateDeviceStatusDTO;
}, unknown>) => import("react-query").UseMutationResult<DeviceDTO, Error_1, {
    id: string;
    data: UpdateDeviceStatusDTO;
}, unknown>;
export declare const deviceControllerGetAllSmartMeterReadings: <Data = unknown>(id: string) => Promise<Data extends unknown ? SmartMeterReadDTO[] : Data>;
export declare const getDeviceControllerGetAllSmartMeterReadingsQueryKey: (id: string) => string[];
export declare const useDeviceControllerGetAllSmartMeterReadings: <Data extends unknown = unknown, Error_1 extends unknown = unknown>(id: string, queryConfig?: UseQueryOptions<SmartMeterReadDTO[], Error_1, SmartMeterReadDTO[], import("react-query").QueryKey>) => {
    data: undefined;
    error: null;
    isError: false;
    isIdle: true;
    isLoading: false;
    isLoadingError: false;
    isRefetchError: false;
    isSuccess: false;
    status: "idle";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<SmartMeterReadDTO[], Error_1>>;
    remove: () => void;
    queryKey: string[];
} | {
    data: undefined;
    error: Error_1;
    isError: true;
    isIdle: false;
    isLoading: false;
    isLoadingError: true;
    isRefetchError: false;
    isSuccess: false;
    status: "error";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<SmartMeterReadDTO[], Error_1>>;
    remove: () => void;
    queryKey: string[];
} | {
    data: undefined;
    error: null;
    isError: false;
    isIdle: false;
    isLoading: true;
    isLoadingError: false;
    isRefetchError: false;
    isSuccess: false;
    status: "loading";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<SmartMeterReadDTO[], Error_1>>;
    remove: () => void;
    queryKey: string[];
} | {
    data: SmartMeterReadDTO[];
    error: Error_1;
    isError: true;
    isIdle: false;
    isLoading: false;
    isLoadingError: false;
    isRefetchError: true;
    isSuccess: false;
    status: "error";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<SmartMeterReadDTO[], Error_1>>;
    remove: () => void;
    queryKey: string[];
} | {
    data: SmartMeterReadDTO[];
    error: null;
    isError: false;
    isIdle: false;
    isLoading: false;
    isLoadingError: false;
    isRefetchError: false;
    isSuccess: true;
    status: "success";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<SmartMeterReadDTO[], Error_1>>;
    remove: () => void;
    queryKey: string[];
};
export declare const deviceControllerAddSmartMeterReads: <Data = unknown>(id: string, smartMeterReadDTO: SmartMeterReadDTO[]) => Promise<Data extends unknown ? SuccessResponseDTO : Data>;
export declare const useDeviceControllerAddSmartMeterReads: <Data extends unknown = unknown, Error_1 extends unknown = unknown>(mutationConfig?: UseMutationOptions<SuccessResponseDTO, Error_1, {
    id: string;
    data: SmartMeterReadDTO[];
}, unknown>) => import("react-query").UseMutationResult<SuccessResponseDTO, Error_1, {
    id: string;
    data: SmartMeterReadDTO[];
}, unknown>;
export declare const deviceControllerGetByExternalId: <Data = unknown>(type: string, id: string) => Promise<Data extends unknown ? DeviceDTO : Data>;
export declare const getDeviceControllerGetByExternalIdQueryKey: (type: string, id: string) => string[];
export declare const useDeviceControllerGetByExternalId: <Data extends unknown = unknown, Error_1 extends unknown = unknown>(type: string, id: string, queryConfig?: UseQueryOptions<DeviceDTO, Error_1, DeviceDTO, import("react-query").QueryKey>) => {
    data: undefined;
    error: null;
    isError: false;
    isIdle: true;
    isLoading: false;
    isLoadingError: false;
    isRefetchError: false;
    isSuccess: false;
    status: "idle";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<DeviceDTO, Error_1>>;
    remove: () => void;
    queryKey: string[];
} | {
    data: undefined;
    error: Error_1;
    isError: true;
    isIdle: false;
    isLoading: false;
    isLoadingError: true;
    isRefetchError: false;
    isSuccess: false;
    status: "error";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<DeviceDTO, Error_1>>;
    remove: () => void;
    queryKey: string[];
} | {
    data: undefined;
    error: null;
    isError: false;
    isIdle: false;
    isLoading: true;
    isLoadingError: false;
    isRefetchError: false;
    isSuccess: false;
    status: "loading";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<DeviceDTO, Error_1>>;
    remove: () => void;
    queryKey: string[];
} | {
    data: DeviceDTO;
    error: Error_1;
    isError: true;
    isIdle: false;
    isLoading: false;
    isLoadingError: false;
    isRefetchError: true;
    isSuccess: false;
    status: "error";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<DeviceDTO, Error_1>>;
    remove: () => void;
    queryKey: string[];
} | {
    data: DeviceDTO;
    error: null;
    isError: false;
    isIdle: false;
    isLoading: false;
    isLoadingError: false;
    isRefetchError: false;
    isSuccess: true;
    status: "success";
    dataUpdatedAt: number;
    errorUpdatedAt: number;
    failureCount: number;
    isFetched: boolean;
    isFetchedAfterMount: boolean;
    isFetching: boolean;
    isPlaceholderData: boolean;
    isPreviousData: boolean;
    isStale: boolean;
    refetch: (options?: import("react-query").RefetchOptions) => Promise<import("react-query").QueryObserverResult<DeviceDTO, Error_1>>;
    remove: () => void;
    queryKey: string[];
};
export {};
