export interface ExternalDeviceIdTypeDTO {
    type: string;
    autogenerated?: boolean;
    required?: boolean;
}
export declare type ConfigurationDTORegions = {};
export interface ConfigurationDTO {
    countryName?: string;
    currencies?: string[];
    regions?: ConfigurationDTORegions;
    externalDeviceIdTypes?: ExternalDeviceIdTypeDTO[];
    complianceStandard?: string;
    deviceTypes?: string[][];
    gridOperators?: string[];
}
export declare type DeviceStatus = 'Submitted' | 'Denied' | 'Active';
export declare const DeviceStatus: {
    Submitted: DeviceStatus;
    Denied: DeviceStatus;
    Active: DeviceStatus;
};
export interface SmartMeterReadDTO {
    meterReading: string;
    timestamp: number;
}
export interface ExternalDeviceIdDTO {
    id: string;
    type: string;
}
export interface SmartMeterStatsDTO {
    certified: string;
    uncertified: string;
}
export interface DeviceDTO {
    status: DeviceStatus;
    facilityName: string;
    description: string;
    images: string;
    address: string;
    capacityInW: number;
    gpsLatitude: string;
    gpsLongitude: string;
    timezone: string;
    complianceRegistry: string;
    otherGreenAttributes: string;
    typeOfPublicSupport: string;
    deviceType: string;
    region: string;
    province: string;
    country: string;
    operationalSince: number;
    gridOperator: string;
    smartMeterReads?: SmartMeterReadDTO[];
    files?: string;
    externalDeviceIds?: ExternalDeviceIdDTO[];
    deviceGroup?: string;
    id: number;
    meterStats?: SmartMeterStatsDTO;
    organizationId: number;
}
export interface CreateDeviceDTO {
    status: DeviceStatus;
    facilityName: string;
    description: string;
    images: string;
    address: string;
    capacityInW: number;
    gpsLatitude: string;
    gpsLongitude: string;
    timezone: string;
    complianceRegistry: string;
    otherGreenAttributes: string;
    typeOfPublicSupport: string;
    deviceType: string;
    region: string;
    province: string;
    country: string;
    operationalSince: number;
    gridOperator: string;
    smartMeterReads?: SmartMeterReadDTO[];
    files?: string;
    externalDeviceIds?: ExternalDeviceIdDTO[];
    deviceGroup?: string;
}
export interface SuccessResponseDTO {
    success: boolean;
    message?: string;
}
export interface UpdateDeviceStatusDTO {
    status: DeviceStatus;
}
export declare type DeviceControllerGetAllParams = {
    withMeterStats?: boolean;
};
export declare type DeviceControllerGetMyDevicesParams = {
    withMeterStats?: boolean;
};
export declare type DeviceControllerGetParams = {
    withMeterStats?: boolean;
};
